﻿#include "toshset.h"

string ranstr[MAXN],toSlove[MAXN],rData[MAXN];
int lData[MAXN],randList[MAXN];
void randomStr();

int main(void){
    cout<<"Making Data(N="<<MAXN<<")..."<<endl;
    srand(time(NULL));
    randomStr();
    for (int i=0;i<MAXN;++i)
        randList[i]=i;
    for (int i=0;i<MAXN;++i)
        swap(randList[rand()%MAXN],randList[rand()%MAXN]);
    for (int i=0;i<MAXN;++i){
        rData[i]=ranstr[randList[i]];
        lData[i]=rand()%2048;
        //cout<<rData[i]<<' '<<lData[i]<<endl;
    }
    cout<<"-------------------------------------------------------------------------------"<<endl;
    for (int i=0;i<MAXN/2;++i)
        toSlove[i]=ranstr[rand()%MAXN];
    cout<<"Maped by unordered_map(STL):"<<flush;
    clock_t Wbyhashtime=Wbyhash(rData,lData,toSlove);
    cout<<Wbyhashtime<<endl;
    cout<<"Maped by map(STL):"<<flush;
    clock_t Wbymaptime=Wbymap(rData,lData,toSlove);
    cout<<Wbymaptime<<endl;
    cout<<"Maped by binary_search(no recursion):"<<flush;
    clock_t WbybintimeN=Wbybin_N(rData,lData,toSlove);
    cout<<WbybintimeN<<endl;
    cout<<"Maped by binary_search(recursion):"<<flush;
    clock_t WbybintimeY=Wbybin_Y(rData,lData,toSlove);
    cout<<WbybintimeY<<endl;
    return 0;
}

void randomStr(){
    for (int i=0;i<MAXN;++i){
        ranstr[i].resize(30);
        for (int j=0;j<25;++j)
            ranstr[i][j]=65+rand()%26;
    }
}
