#ifndef TOSHSET_H_INCLUDED
#define TOSHSET_H_INCLUDED

#include <iostream>
#include <cstdlib>
#include <ctime>
#include <string>
#include <tr1/unordered_map>
#include <map>
#include <algorithm>
using namespace std;
using tr1::unordered_map;

const int MAXN=5000000;

clock_t Wbyhash(const string[],const int[],const string[]);
clock_t Wbymap(const string[],const int[],const string[]);
clock_t Wbybin_N(const string[],const int[],const string[]);
clock_t Wbybin_Y(const string[],const int[],const string[]);
int WbybinY_real(int,int,const string&);

struct strhash{
    size_t operator()(const string & str) const{
        size_t h=0;
        for(size_t i=0;i<str.size();++i){
            h=(h<<5)-h+str[i];
        }
        return h;
        //return __stl_hash_string(str.c_str());
    }
};
struct strcmps{
    bool operator()(const string& str1,const string& str2) const{
        return str1==str2;
    }
};

#endif // TOSHSET_H_INCLUDED
